//  This file was generated by LevelHelper
//  http://www.levelhelper.org
//
//  LevelHelperLoader.h
//  Created by Bogdan Vladu
//  Copyright 2011 Bogdan Vladu. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
//
//  This software is provided 'as-is', without any express or implied
//  warranty.  In no event will the authors be held liable for any damages
//  arising from the use of this software.
//  Permission is granted to anyone to use this software for any purpose,
//  including commercial applications, and to alter it and redistribute it
//  freely, subject to the following restrictions:
//  The origin of this software must not be misrepresented; you must not
//  claim that you wrote the original software. If you use this software
//  in a product, an acknowledgment in the product documentation would be
//  appreciated but is not required.
//  Altered source versions must be plainly marked as such, and must not be
//  misrepresented as being the original software.
//  This notice may not be removed or altered from any source distribution.
//  By "software" the author refers to this code file and not the application 
//  that was used to generate this file.
//
////////////////////////////////////////////////////////////////////////////////

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#include "Box2D.h"

@class LHSprite;
@class LevelHelperLoader;

enum LH_JOINT_TYPE
{
	LH_DISTANCE_JOINT = 0,
	LH_REVOLUTE_JOINT,
	LH_PRISMATIC_JOINT,
	LH_PULLEY_JOINT,
	LH_GEAR_JOINT,
	LH_WHEEL_JOINT,
	LH_WELD_JOINT,
	LH_ROPE_JOINT,
	LH_FRICTION_JOINT,
    LH_UNKNOWN_TYPE
};

@interface LHJoint : NSObject
{
	b2Joint* joint; //week ptr
    b2World* boxWorld;
    NSString* uniqueName;

    int tag;
    LH_JOINT_TYPE type;
    
    LevelHelperLoader* parentLoader;
    
    bool shouldDestroyJointOnDealloc;
}
@property int tag;
@property (readonly) NSString* uniqueName;
@property enum LH_JOINT_TYPE type;
@property (readwrite) bool shouldDestroyJointOnDealloc;
////////////////////////////////////////////////////////////////////////////////
+(id) jointWithDictionary:(NSDictionary*)dictionary 
                    world:(b2World*)box2d 
                   loader:(LevelHelperLoader*)pLoader;

////////////////////////////////////////////////////////////////////////////////
-(b2Joint*)joint;
-(bool) removeJointFromWorld;

-(LHSprite*) spriteA;
-(LHSprite*) spriteB;


+(bool) isLHJoint:(id)object;
+(LHJoint*) jointFromBox2dJoint:(b2Joint*)jt;

//remove itself from the world - make sure you dont retain this object
//if the box2d world is locked it will mark the joint for removal
//you need to call [loader removeMarkedJoints]; at the end of your tick method
-(void)removeSelf;
@end	
